/*
 * escpf [ESC/P lpr filter version 0.2]		1995,03,12
 *
 *	Copyright 1995 by Hideya Hane
 *
 *		0.2	some bug fix
 *		0.1	make escpf from bj10f	1995,01,28
 */

#include	<stdio.h>
#include	<strings.h>
#include	"escpf.h"

#undef		ARGCHK
#undef		DEBUG

void col_inc(int *col_chk);
void head_section( void );
extern void of_proc( int ac );

static char *escpfid = "escpf Ver0.2 '95,3,12";

/* defaults settings */
int lines	= 66;
int columns	= 80;
int top_mergin	= 0;
int left_mergin	= 2;

int col_count  = 0;
int line_count = 0;
int tmp_loop;
int loop_exit_status;

unsigned char read_data, read_data2, read_data3;
int char_mode = 0;		/* 0:ASCII 1:EUC 2:JIS */
int kchk;

int main(int argc, char **argv)
{
    int i;
#ifdef DEBUG
    FILE *fp;

    if( (fp = fopen("/dev/console","w")) == NULL ) {
	perror("fopen");
	exit(-1);
    }
#endif

    /* if called of filter */
    of_proc(argc);

#ifdef ARGCHK
    for(i = 0; i < argc; i++)
	printf("%s\n",argv[i]);
#endif

    /* set lines/page */
    for(i = 0; i < argc; i++){
	if(strncmp(argv[i],"-l",2) == (int)NULL){
	    lines = atoi(argv[i] + 2);
	}
	if(strncmp(argv[i],"-w",2) == (int)NULL){
	    columns = atoi(argv[i] + 2);
	}
    }
#ifdef ARGCHK
    printf("%d:%d\n",lines,columns);
#endif

    /* set kanji pitch. This is not enough. */
    set_kanji_pitch();

    /* Set 12CPI */
    set_12_cpi_mode();

    /* Set Left Mergin (4 space) */
    set_left_mergin(left_mergin);

    printf("%c%c%c",0x1b,0x43,lines+10);

    /* 1st top mergin and head */
    /* head_section(); */

    while ((read_data = getchar()) != (unsigned char) EOF) {
	loop_exit_status = 0;
	/*
	 * process of charactor data
	 */
	if (read_data < 0x80) {
	    if (read_data == JIS_KANJI_IN_1) {		/* if JIS KANJI */
		read_data2 = getchar();
		if (read_data2 == JIS_KANJI_IN_2) {
		    read_data3 = getchar();
		    if (read_data3 == JIS_KANJI_IN_3) {
			kanji_in();

			kchk = 0;
			char_mode = 2;
			while ((read_data = getchar()) != 0x1b) {
			    putchar(read_data);
			    kchk++;
			    col_inc(&col_count);
			}
			char_mode = 0;
			getchar();
			getchar();
			kanji_out();
		    } else {
			buf_flush();
		    }
		}else{ /* other ESC sequence */
		    putchar(read_data);
		    putchar(read_data2);
		}
	    } else {
		if (char_mode == 1) {
		    char_mode = 0;
		    kanji_out();
		}
		/*
		 * process of PAGE_FEED
		 */
		if( read_data == PAGE_FEED ){
		    putchar(read_data);
		    line_count = 0;
		    /*
		    getchar();
		    putchar(read_data);
		    */
		    /* head_section(); */
		} else if( read_data == CR ){
		    /*
		    if(col_count == 0){
			loop_exit_status = 1;
		    }
		    */
		    putchar(read_data);
		    col_count = 0;
		    line_count++;
		    if( lines == line_count ){
			/*
			 * process of page number
			 */
			line_count = 0;
			read_data = PAGE_FEED;
			putchar(read_data);
			/* head_section(); */
		    }
		}else{
		    putchar(read_data);		/* output ANK */
		    col_inc(&col_count);
		}
	    }
	} else {				/* if EUC KANJI */
	    /* flag set to KANJI */
	    if (char_mode == 0) {
		char_mode = 1;
		kanji_in();
		kchk = 0;
	    }
	    putchar(0x7f & read_data);
	    kchk++;
	    col_inc(&col_count);
	}
    } /* end of stream read while loop. na,nagai...... */
#ifdef DEBUG
    fprintf(fp,"%d,%d,%d\n",col_count,line_count,read_data);
#endif
    /* output page feed */
    if((col_count > 0) || (line_count > 0)){
	putchar(PAGE_FEED);
    }

    exit(0);
}


void
head_section()
{
    /* top mergin */
    /*
    for(tmp_loop = 0; tmp_loop < top_mergin; tmp_loop++){
	putchar(CR);
    }
    */
}

void
col_inc(int *col_chk)
{
    (*col_chk)++;

    if(*col_chk > columns){
	if(char_mode > 0){
	    if((kchk % 2) == 1){
		read_data = getchar();
		putchar(0x7f & read_data);
		/*
		if(char_mode == 2){
		    getchar();
		    getchar();
		}
		*/
	    }
	    kanji_out();
	}

	*col_chk = 0;
	putchar(CR);
	line_count++;
	if( lines == line_count ){
	    /*
	     * process of page number
	     */
	    line_count = 0;
	    putchar(PAGE_FEED);
	    /* head_section(); */
	}

	if(char_mode > 0){
	    kanji_in();
	}
    }
}
